        .messg "ram"
        .subttl "ram"
        .page

PAGE_0          .EQU    $0002           ; Start of Page Zero variables

jobs            .equ    PAGE_0          ; job que = 8 last 2 for bams
hdrs            .equ    PAGE_0+9        ; job headers
dskid           .equ    PAGE_0+27       ; master copy of disk id
header          .equ    PAGE_0+29       ; image of last header
wpsw            .equ    PAGE_0+35       ; write protect change flag
drvst           .equ    PAGE_0+36       ; lcc var's

                                        ; bits 7 6 5 4  3 2 1 0
                                        ;
                                        ;            -- timeout
                                        ;          ---- running
                                        ;        ------ stepping
                                        ;      -------- accelerating
                                        ;
                                        ; ie:
                                        ;      $00 = no drive active
                                        ;      $20 = running
                                        ;      $30 = running and timeout
                                        ;      $50 = stepping and running
                                        ;      $80 = accelerating

drvtrk          .equ    PAGE_0+37       ;
cmd             .equ    PAGE_0+38       ; temp job command
cmdsiz          .equ    PAGE_0+39       ; command string size
acltim          .equ    PAGE_0+40       ; acceleration/decceleration time delay
savsp           .equ    PAGE_0+42       ; save stack pointer
autofg          .equ    PAGE_0+43       ; auto init flag
secinc          .equ    PAGE_0+44       ; sector inc for seq
ftnum           .equ    PAGE_0+45       ;
revcnt          .equ    PAGE_0+46       ; error recovery count
bmpnt           .equ    PAGE_0+47       ; bit map pointer
usrjmp          .equ    PAGE_0+49       ; user jmp table ptr
wbam            .equ    PAGE_0+51       ; bam status (0=clean)
ctmp            .equ    PAGE_0+52       ; temps
tmp             .equ    PAGE_0+54       ;
tmpjbn          .equ    PAGE_0+61       ;
temp            .equ    PAGE_0+62       ; work space
t0              .equ    temp            ;
t1              .equ    temp+1          ;
t2              .equ    temp+2          ;
t3              .equ    temp+3          ;
t4              .equ    temp+4          ;
ip              .equ    PAGE_0+68       ; indirect ptr variable
prgtrk          .equ    PAGE_0+74       ; last prog accessed
track           .equ    PAGE_0+75       ; current track
sector          .equ    PAGE_0+76       ; current sector
tos             .equ    PAGE_0+77       ; top of stack (def: -1-7fh)
lindx           .equ    PAGE_0+78       ; logical index
eoiflg          .equ    PAGE_0+79       ; temp eoi
sa              .equ    PAGE_0+80       ; secondary address
orgsa           .equ    PAGE_0+81       ; original sa
data            .equ    PAGE_0+82       ; temp data byte
r0              .equ    PAGE_0+83       ;
r1              .equ    PAGE_0+84       ;
r2              .equ    PAGE_0+85       ;
r3              .equ    PAGE_0+86       ;
r4              .equ    PAGE_0+87       ;
r5              .equ    PAGE_0+88       ;
result          .equ    PAGE_0+89       ;
accum           .equ    PAGE_0+93       ;
dirbuf          .equ    PAGE_0+98       ;
cont            .equ    PAGE_0+100      ; bit counter for ser
f1ptr           .equ    PAGE_0+101      ; file stream 1 pointer
recptr          .equ    PAGE_0+102      ;
ssnum           .equ    PAGE_0+103      ;
ssind           .equ    PAGE_0+104      ;
relptr          .equ    PAGE_0+105      ;
jobnum          .equ    PAGE_0+106      ; current job #
bufuse          .equ    PAGE_0+107      ; buffer allocation
nodrv           .equ    PAGE_0+108      ; no drive flag
dskver          .equ    PAGE_0+109      ; disk version
linuse          .equ    PAGE_0+110      ; lindx use word
dirsec          .equ    PAGE_0+111      ; directory sector
delsec          .equ    PAGE_0+112      ; sector of 1st avail entry
delind          .equ    PAGE_0+113      ; index "
lbused          .equ    PAGE_0+114      ; last buffer used
numsec          .equ    PAGE_0+115      ; number of sectors logical
fsflag          .equ    PAGE_0+116      ; fast serial flag

                                        ; bits 7 6 5 4  3 2 1 0 
                                        ;                     - atn pending
                                        ;                   --- atn mode
                                        ;                 ----- clkin status
                                        ;               ------- fast serial lock
                                        ;            ---------- slow flag
                                        ;          ------------ fast serial flag
                                        ;        -------------- listen flag
                                        ;      ---------------- talk flag

lsnadr          .equ    PAGE_0+117      ; listen address
tlkadr          .equ    PAGE_0+118      ; talker address
ledprint        .equ    PAGE_0+119      ; led var

                                        ; bits 7 6 5 4  3 2 1 0 
                                        ;
                                        ;          -- blink power led
                                        ;        ----- activity led

tempsa          .equ    PAGE_0+120      ; temporary sa
cmdwat          .equ    PAGE_0+121      ; command waiting flag
switch          .equ    PAGE_0+122      ; burst command switch
controller_stat .equ    PAGE_0+123      ; controller status
bufpnt          .equ    PAGE_0+124      ; buffer pointer
dkmode          .equ    PAGE_0+126      ; burst status
xjobrtn         .equ    PAGE_0+127      ;
yreg            .equ    PAGE_0+128      ; yreg
nextjob         .equ    PAGE_0+129      ; controller nextjob
cindex          .equ    PAGE_0+130      ; controller job index
info            .equ    PAGE_0+131      ; controller job information variable
dirty           .equ    PAGE_0+133      ; track cache dirty flag
cmdtrk          .equ    PAGE_0+134      ; controller destination track
dkandmask       .equ    PAGE_0+135      ; burst status mask
dkoramask       .equ    PAGE_0+136      ; burst status mask
cache           .equ    PAGE_0+137      ; cache pointer
iobyte          .equ    PAGE_0+139      ; verify / crc check

                                        ; bits 7 6 5 4  3 2 1 0
                                        ;        --- huge rel = 0
                                        ;        ---- crc check = 1
                                        ;      ------- verify = 1

pstartrk        .equ    PAGE_0+140      ; physical starting track
pmaxtrk         .equ    PAGE_0+141      ; "      " ending track
startrk         .equ    PAGE_0+142      ; logical starting track
psectorsiz      .equ    PAGE_0+143      ; physical sector size
pnumsec         .equ    PAGE_0+144      ; physical number of sectors (side)
pendsec         .equ    PAGE_0+145      ; physical ending sector
pstartsec       .equ    PAGE_0+146      ; physical starting sector
cachetrk        .equ    PAGE_0+147      ; current physical track cache
tcacheside      .equ    PAGE_0+148      ; translated current track cache side
cacheside       .equ    PAGE_0+149      ; current track cache side
setval          .equ    PAGE_0+150      ; settling time value
hdrjob          .equ    PAGE_0+151      ; shifted nextjob - hdr pointer
gap3            .equ    PAGE_0+152      ; format gap
fillbyte        .equ    PAGE_0+153      ; format fill byte
sieeetim        .equ    PAGE_0+154      ; sieee timing
sieeeset        .equ    PAGE_0+155      ; sieee timing
blink           .equ    PAGE_0+156      ; error blinking
cacheoff        .equ    PAGE_0+157      ; translated track cache offset

lintab          .equ    PAGE_0+147+maxsa+1      ; sa:lindx table
buftab          .equ    PAGE_0+163+cbptr+4      ; buffer byte pntrs
cb              .equ    buftab+cbptr            ; buftab+cbptr
buf0            .equ    PAGE_0+200+mxchns       ;
buf1            .equ    PAGE_0+207+mxchns       ;
lrutbl          .equ    PAGE_0+215+mxchns-1     ; least recently used table
entsec          .equ    PAGE_0+222+mxfils       ; sector of directory entry
entind          .equ    PAGE_0+227+mxfils       ; index of directory entry
fildrv          .equ    PAGE_0+232+mxfils       ; default flag, drive #
pattyp          .equ    PAGE_0+237+mxfils       ; pattern,replace,closed-flags,type
filtyp          .equ    PAGE_0+240+mxchns       ; channel file type

; huge relfile stuff

grpnum          .equ    PAGE_0+254      ; group number
relsw           .equ    PAGE_0+255      ; huge relfile switch

                                        ; bits 7 6 5 4  3 2 1 0
                                        ;
                                        ;           -- overflow = 1
                                        ;          --- huge rel file = 0

sssgrp          .equ    PAGE_0+256      ; super ss group
ssssec          .equ    PAGE_0+263      ; super ss sector
ssstrk          .equ    PAGE_0+270      ; super ss track

svects          .equ    $190
vidle           .equ    svects+0        ; indirect for idle
virq            .equ    svects+2        ; indirect for irq
vnmi            .equ    svects+4        ; indirect for nmi
vverdir         .equ    svects+6        ; commands
vintdrv         .equ    svects+8        ;
vpart           .equ    svects+10       ;
vmem            .equ    svects+12       ;
vblock          .equ    svects+14       ;
vuser           .equ    svects+16       ;
vrecord         .equ    svects+18       ;
vutlodr         .equ    svects+20       ;
vdskcpy         .equ    svects+22       ;
vrename         .equ    svects+24       ;
vscrtch         .equ    svects+26       ;
vnew            .equ    svects+28       ;
verror          .equ    svects+30       ;
vatnsrv         .equ    svects+32       ;
vtalk           .equ    svects+34       ;
vlisten         .equ    svects+36       ;
vlcc            .equ    svects+38       ;
vtrans_ts       .equ    svects+40       ; track & sector translation
vcmder2         .equ    svects+42       ; DOS command error

hdrs2           .equ    svects+44       ; translated job headers
sids            .equ    svects+62       ; side select for physical
ctltimh         .equ    svects+71       ; controller timer var
ctltiml         .equ    svects+72       ; *
motoracc        .equ    svects+73       ; acceleration startup

; controller commands

wdrestore       .equ    svects+74       ; $08
wdseek          .equ    svects+75       ; $18
wdstep          .equ    svects+76       ; $28
wdstepin        .equ    svects+77       ; $48
wdstepout       .equ    svects+78       ; $68
wdreadsector    .equ    svects+79       ; $88
wdwritesector   .equ    svects+80       ; $aa
wdreadaddress   .equ    svects+81       ; $c8
wdreadtrack     .equ    svects+82       ; $e8
wdwritetrack    .equ    svects+83       ; $fa
wdforceirq      .equ    svects+84       ; $d0

dirst           .equ    svects+85       ; starting directory sector
savects         .equ    svects+86       ; save area for vectors
burst_stat      .equ    svects+90       ; burst controller status
vernum          .equ    svects+91       ; DOS version number
dosver          .equ    svects+92       ; & type
hi              .equ    svects+93       ; high partition counter
lo              .equ    svects+94       ; low "         "
minsek          .equ    svects+95       ; burst min. sector #
maxsek          .equ    svects+96       ; "  "  max. "    "
bufind          .equ    svects+97       ; buffer indirects
wpstat          .equ    svects+106      ; write protect status
dejavu          .equ    svects+107      ; auto boot flag

                                        ; bits 7 6 5 4  3 2 1 0
                                        ;
                                        ;        ---- boot on intdrv
                                        ;      ------- boot on reset

jhandsk         .equ    svects+108      ; handsk jmp

                .org    $0200

BUFF            .equ    $0200           ; Buffer start

cmdbuf          .equ    BUFF            ; command buffer
cmdnum          .equ    BUFF+42         ; command #
dirtrk          .equ    BUFF+43         ; system track
maxtrk          .equ    BUFF+44         ; max track + 1
type            .equ    BUFF+45         ; active file type
f1cnt           .equ    BUFF+46         ; file stream 1 count
f2cnt           .equ    BUFF+47         ; file stream 2 count
f2ptr           .equ    BUFF+48         ; file stream 2 pointer
filcnt          .equ    BUFF+49         ; counter, file entries
index           .equ    BUFF+50         ; current index in buffer
typflg          .equ    BUFF+51         ; match by type flag
chnrdy          .equ    BUFF+52         ; channel status
chndat          .equ    BUFF+52+mxchns  ; channel data byte
lstchr          .equ    BUFF+59+mxchns  ; channel last char ptr
nbkl            .equ    BUFF+66+mxchns  ;
recl            .equ    BUFF+66+mxchns  ;
nbkh            .equ    BUFF+73+mxchns-1;
rech            .equ    BUFF+73+mxchns  ;
nr              .equ    BUFF+80+mxchns  ;
rs              .equ    BUFF+87+mxchns  ;
ss              .equ    BUFF+94+mxchns  ;
strsiz          .equ    BUFF+108        ;
entfnd          .equ    BUFF+109        ; dir-entry found flag
dirlst          .equ    BUFF+110        ; dir listing flag
rec             .equ    BUFF+111        ;
trkss           .equ    BUFF+112        ;
secss           .equ    BUFF+113        ;
lstjob          .equ    BUFF+114        ; last job
dsec            .equ    BUFF+118+mxchns ; sec of dir entry
dind            .equ    BUFF+125+mxchns ; index of dir entry
prgsec          .equ    BUFF+139        ; last program sector
wlindx          .equ    BUFF+140        ; write lindx
nbtemp          .equ    BUFF+141        ; # blocks temp
char            .equ    BUFF+143        ; char under parser
limit           .equ    BUFF+144        ; ptr limit in compar
filtbl          .equ    BUFF+145        ; filename pointer
filtrk          .equ    BUFF+146+mxfils ; 1st link/track
filsec          .equ    BUFF+151+mxfils ; /sector
patflg          .equ    BUFF+156+mxfils ; pattern presence flag
image           .equ    BUFF+162        ; file stream image
drvcnt          .equ    BUFF+163        ; number of drv searches
drvflg          .equ    BUFF+164        ; drive search flag
found           .equ    BUFF+165        ; found flag in dir searches
lstbuf          .equ    BUFF+166        ; =0 if last block
mode            .equ    BUFF+167        ; active file mode (r,w)
jobrtn          .equ    BUFF+168        ; job return flag
ndbl            .equ    BUFF+169        ; # of disk blocks free
ndbh            .equ    BUFF+170        ;
erword          .equ    BUFF+171        ; error word for recovery
nambuf          .equ    BUFF+172        ; directory buffer
errbuf          .equ    BUFF+172+36     ; error msg buffer

