        NAM  1581 DOS v10  318045-01  (c)1987 CBM
        PL      66      ;Page Length
        PW      132     ;Page Width (# of char/line)
        INCLIST ON

;**********************************************
; 318045-01 ROM    03/20/87   F.BOWEN    $8E8B
;**********************************************
; Updated for WDC Tools 01/07/2017 K.Maier
; a bit ugly but assembles correctly and
; provides a binary match on the ROM image
;**********************************************
; Updated for CMOS instructions on 07/23/2019
; much code reduction as well plus a coulple of
; bug fixes - K.Maier
;**********************************************
; 318045-02 ROM patches are in:
; DSKINT.ASM line 109
; MCNTL.ASM line 112 and MROUT.ASM line 499
;**********************************************
; 381045-03C ROM   08/18/2019  K. Maier $1A03
; Updated for additional CMOS instructions and
; addressing modes... Init routines changed,
; 3ms step rates now in effect and no longer
; requires 8520A (24-bit counter used). The
; 6525A can be used in place with no hardware
; changes.
; NOTE: ROM checksum not currently implemented
; which is the same the -02 ROM version. This
; will be put back in for the next update. I
; suspect the Signature also does not function
; properly as a result.
;**********************************************

        INCLUDE mfmmacro.asm
        INCLUDE common.asm
        INCLUDE equate.asm
        INCLUDE iodef.asm
        INCLUDE ram.asm
        INCLUDE dversion.asm
        INCLUDE parsex.asm
        INCLUDE setdrv.asm
        INCLUDE lookitup.asm
        INCLUDE trnsfr.asm
        INCLUDE scrtch.asm
        INCLUDE formatd.asm
        INCLUDE copy.asm
        INCLUDE rename.asm
        INCLUDE memrw.asm
        INCLUDE blk.asm
        INCLUDE fndrel.asm
        INCLUDE tst2.asm
        INCLUDE tst3.asm
        INCLUDE tst4.asm
        INCLUDE tst5.asm
        INCLUDE job.asm
        INCLUDE addfil.asm
        INCLUDE open.asm
        INCLUDE close.asm
        INCLUDE opchnl.asm
        INCLUDE tstflg.asm
        INCLUDE tsutil.asm
        INCLUDE ssutil.asm
        INCLUDE sstest.asm
        INCLUDE getact.asm
        INCLUDE rel1.asm
        INCLUDE rel2.asm
        INCLUDE rel3.asm
        INCLUDE rel4.asm
        INCLUDE ssend.asm
        INCLUDE record.asm
        INCLUDE nulbuf.asm
        INCLUDE addrel.asm
        INCLUDE newss.asm
        INCLUDE system.asm
        INCLUDE erproc.asm
        INCLUDE utlodr.asm
        INCLUDE utl.asm
        INCLUDE signatur.asm
        INCLUDE sieee.asm
        INCLUDE dskint.asm
        INCLUDE idle.asm
        INCLUDE lstdir.asm
        INCLUDE verdir.asm
        INCLUDE newdsk.asm
        INCLUDE mapit.asm
        INCLUDE frets.asm
        INCLUDE bamutl.asm
        INCLUDE tstfnd.asm
        INCLUDE part.asm
        INCLUDE fastld.asm
        INCLUDE burstc.asm
        INCLUDE mcntl.asm
        INCLUDE mrout.asm
        INCLUDE msub.asm
        INCLUDE crc.asm
        INCLUDE irq.asm
        INCLUDE romtbl.asm
        INCLUDE relnotes.asm
        INCLUDE vects.asm
        END
