        .messg "iodef"
        .subttl "iodef"
        .page

;I/O definitions

unlsn           .equ    $3f             ; unlisten command
untlk           .equ    $5f             ; untalk command
notrdy          .equ    $00             ; not ready
eoiout          .equ    $80             ; talk with eoi
eoi             .equ    $08             ; eoi
eoisnd          .equ    $08             ; not(eoi) to send
rdytlk          .equ    $88             ; talk no eoi
rdylst          .equ    $01             ; ready to listen

; random chnrdy

rndrdy          .equ    rdytlk+rdylst

; random w/ eoi

rndeoi          .equ    eoiout+rdylst

MOS8520A        .equ    $4000

; 8520A or 6526A CIA (Complex Interface Adaptor)

pa              .equ    MOS8520A+0      ; port a
side_sel        .equ    bit0            ; out
drv_rdy         .equ    bit1            ; in
mtr_on          .equ    bit2            ; out
dev_sel1        .equ    bit3            ; in
dev_sel2        .equ    bit4            ; in
pwr_led         .equ    bit5            ; out
act_led         .equ    bit6            ; out
disk_change     .equ    bit7            ; in

init_dd_pa      .equ    %01100101
init_prt_pa     .equ    %11111110       ;

pb              .equ    MOS8520A+1      ; port b
datin           .equ    bit0            ; in
datout          .equ    bit1            ; out
clkin           .equ    bit2            ; in
clkout          .equ    bit3            ; out
atna            .equ    bit4            ; out
fsdir           .equ    bit5            ; out
wpin            .equ    bit6            ; in
atnrd           .equ    bit7            ; in

init_dd_pb      .equ    %00111010
init_prt_pb     .equ    %11010101

ddpa            .equ    MOS8520A+2      ; dd port a
ddpb            .equ    MOS8520A+3      ; dd port b
tima_l          .equ    MOS8520A+4      ; timer a used for the baud rate generator
tima_h          .equ    MOS8520A+5      ; *
timb_l          .equ    MOS8520A+6      ; timer b used for controller irqs
timb_h          .equ    MOS8520A+7      ; *

todlsb          .equ    MOS8520A+8      ; event lsb, used for disk change detector
tod8_15         .equ    MOS8520A+9      ; event 8-15
todmsb          .equ    MOS8520A+10     ; event msb
noconnect       .equ    MOS8520A+11     ; unused
sdr             .equ    MOS8520A+12     ; serial data register
icr             .equ    MOS8520A+13     ; interrupt control register
cra             .equ    MOS8520A+14     ; control register a
crb             .equ    MOS8520A+15     ; control register b

WDC1772         .equ    $6000

; WD177X MFM Disk Controller Chip

wdcmd           .equ    WDC1772+0       ; command register
wdstat          .equ    WDC1772+0       ; status register
wdtrk           .equ    WDC1772+1       ; track register
wdsec           .equ    WDC1772+2       ; sector register
wddat           .equ    WDC1772+3       ; data register

